/****************************************/
/*		BH1603ƓxZT[ Ɠx\	*/
/****************************************/
//		ATTINY861gp				
//		8MHzNbN		
//		Fuse  : -fh11011100 -fl11100010
//					DC          E2
//		tool : AVR Studio Version 4, 19, 0, 730

//		ϰ0	1mS荞		
//		LCD		8~2s ACM0802C
//		A/D ch 9:ƓxZT
//		A/D ch 8:drd
//		PA0	  out LCD RS
//		PA1	  out LCD R/W
//		PA2	  out LCD E
//		PA3	  in  AREF
//		PA4	  i/o LCD D4
//		PA5	  i/o LCD D5
//		PA6	  i/o LCD D6
//		PA7	  i/o LCD D7
//		PB0	  out BH1603 G1
//		PB1	  out BH1603 G2
//		PB2	  out MPX 4052 A 
//		PB3	  out MPX 4052 B 
//		PB4	  in  SW 
//		PB5	  in  ADC8 drd
//		PB6	  in  ADC9 BH1603ZT

//		Ɠxx5i גRς9
//			x	0	L0			102300Lx
//					1	L1 M0		 10230Lx
//					2	L2 M1 H0	  1023Lx
//					3	   M2 H1	 102.3Lx
//			x	4         H2	 10.23Lx
//		גR	L0,M0,H0 : 4.7k 
//					L1,M1,H1 : 47k
//					L2,M2,H2 : 470k
//		XCb`Ŋx敪+1 ɊxAbv H2̎L0
//		XCb`̘A삪IĂ3b҂EEPROMɊx敪ۑ
//		2015-02-29	Jn		
//			 03-07	P[Xɑgݍ
//			 08-10	\@傢ƕύX 

/*****	CN[h		*****/
#include <inttypes.h>
#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h> 

/*****	ݻނ̕ϐ`	*****/
typedef	unsigned char		uchar;
typedef	unsigned int		uint;
typedef	unsigned long		ulong;
typedef uint8_t				byte;
typedef uint16_t			word;
typedef uint32_t			lword;

/*****	zްԂϸ		*****/
#define		DIMSIZ(a)	(sizeof(a)/sizeof(*a))

/*****	I/O|[g`			*****/
#define	PI_SW		(1 << PB4)			// XCb` onL
#define	PIN_SW 		(PINB & PI_SW)

/*****	}N			*****/
#define	nop()		asm volatile("nop;")	// NOPR[h

/****************************/
/*		O[of[^	*/
/****************************/

/*****	1mS ^C}[f[^		*****/
volatile byte	tm_1ms;			// 1mS^C}[@_EJEg
volatile byte	tmlcd_busy;		// LCD busy  ϰ
volatile byte	tmlcd_wait;		// LCD ԑ҂ ϰ
volatile byte	tm_gainx;		// QCݒύX^C}[ (0.1sec)
								// ^CAbvŃQClEEPROM
/*****	tO		*****/
volatile byte 	f_tm1ms;		// 1mS^C}[荞݃tO
								// 荞݂ނ̂ŉ̃tOƂ͕ʂ
/*****  XCb`f[^,tO   *****/
//	    荞݂Őݒ肳̂͏O
typedef struct{
    uint8_t    swon:1;           // SW on tO
	uint8_t    lxdisp:1;         // Ɠx\tO
	uint8_t    gdisp:1;          // QC\tO
	uint8_t    gainx:1;          // QCݒύXtO
	uint8_t    batlo:1;          // drdቺtO
}flag;    
flag f;                  // tO̎

/*****	A/D f[^		*****/
#define AD_CH		2			// A/D`l
#define AD_AVR		256			// A/Dω
#define	AD_SENS		0			// ch9 ZT[d
#define	AD_BAT		1			// ch8 drd

volatile byte 	ad_ch;			// A/Dϊ`l
								// 0`1
volatile word 	ad_cnt;			// A/Dω
								// 0`255
volatile lword	ad_add[AD_CH];	// A/DωZl
volatile word   ad_data[AD_CH];	// A/Dσf[^
volatile word   ad_max[AD_CH];	// A/Df[^ől
volatile byte 	ad_ok;			// A/DϊtO
volatile byte 	ad_blcnt;		// _ŗpJE^
volatile byte 	f_blink;		// I[o[W_ŃtO

/****************************/
/*		ddoqnl		*/
/****************************/

/*****	EEPROM f[^		*****/
word eep_dummy		EEMEM = 0;		// _~[

word eep_lowbat		EEMEM = 400;	// Low Batdrd
									// AD_BATƔr
word eep_lowbath	EEMEM = 408;	// Low Bat񕜓d
									// qXeVX
word eep_adsensmin	EEMEM = 2;		// ZT[\mind
									// AD_SENS̒lȉ0
byte eep_sensgain	EEMEM = 0;		// QCݒl 0`8
byte eep_gainxtm	EEMEM = 30;		// QCf[^Z[u҂(0.1sP)

/*****	RAM GA		*****/
word low_bat;						// LOW BAT\pA/Dr
word low_bath;						// qXeVX
word adsens_min;					// ZT[\mind
byte sens_gain;						// QCݒl 0`8
byte gainx_tm;						// QCf[^Z[u҂(0.1sP)

/*****	ǂݏof[^̃AhX	*****/
struct{
	byte	n;			// f[^oCg
	void	*eep;		// EEPROMf[^
	void	*ram;		// RAM̃AhX
}eeproms[]={
	{ sizeof(low_bat),		&eep_lowbat,		&low_bat  	 },		// 0
	{ sizeof(low_bath),		&eep_lowbath,		&low_bath  	 },		// 1
	{ sizeof(adsens_min),	&eep_adsensmin,		&adsens_min  },		// 2
	{ sizeof(sens_gain),	&eep_sensgain,		&sens_gain 	 },		// 3
	{ sizeof(gainx_tm),		&eep_gainxtm,		&gainx_tm 	 },		// 4
};

/*****	EEPROMRAM ǂݏo		*****/
//		RAMɓ]
void eeptoram(void)
{
int i;
void *p;
	for(i = 0; i < DIMSIZ(eeproms); i++){
	  p = eeproms[i].eep;
	  eeprom_busy_wait();				// EEPROMANZX\҂
	  switch(eeproms[i].n){				// oCgŋ敪
		case 1:		// BYTE
		  *(byte *)eeproms[i].ram = eeprom_read_byte((byte *)p);
		  break;		  
		case 2:		//WORD
		  *(word *)eeproms[i].ram = eeprom_read_word((word *)p);
		  break;		  
	  }
	}
}

/****************************/
/*						*/
/****************************/

/*****				*****/
void ioinit(void)
{
	PORTA = 0b00000000;		//
	DDRA  = 0b00000111;
	//	 	  |||||||+----	PA0 out LCD RS
	//		  ||||||+-----	PA1	out LCD R/W
	//		  |||||+------	PA2 out LCD E
	//		  ||||+-------	PA3 in  AREF
	//		  |||+--------	PA4 i/o LCD D4
	//		  ||+---------	PA5 i/o LCD D5
	//		  |+----------	PA6 i/o LCD D6
	//		  +-----------	PA7 i/o LCD D7
	PORTB = 0b00010000;		// PB4 pull up
	DDRB  = 0b00001111;
	//	 	   ||||||+----	PB0 out BH1603 G1
	//		   |||||+-----	PB1	out BH1603 G2
	//		   ||||+------	PB2 out MPX 4052 A
	//		   |||+-------	PB3 out MPX 4052 B
	//		   ||+--------	PB4 in  SW
	//		   |+---------	PB5 in  ADC8
	//		   +----------	PB6 in  ADC9

//	A/D
	DIDR0  = 0b00001000;
	//		       +------	AREF
	DIDR1  = 0b01100000;
	//		    ++--------	A/D	ch9,8
	ADCSRA = 0b10001110;
	//		   |   |+++---	CLK 1/64 125kHz
	//		   |   +------	ADIE
	//		   +----------	ADEN
	ADCSRB = 0b00010000;
	//		   || ||+++---	free run
	//		   || |+------	MUX5
	//		   || +-------	REFS2 AREFpin
	//		   |+---------	GSEL
	//		   +----------	BIN
	ADMUX  = 0b11001001;
	//		   |||+++++---	MUX ch9
	//		   ||+--------	ADLAR
	//		   ++---------	REFS AREFpin
	
//	^C}[0
	TCCR0A = 0b00000001;
	//                +---	CTC0 OCR0Atop
	TCCR0B = 0b00000011;
	//			   |+++---	CLK/64
	//			   +------	PSR0
	OCR0A  = 125-1;			// 1000Hz (8MHz / 64 / 125)
	TIMSK  = 0b00010000;
	//			  +-------	OCIE0A ߯ĺ߱荞
}

/********************************/
/*		^C}[0荞		*/
/********************************/

/*****	^C}[0荞ݏ		*****/
//		A/DϊJn
SIGNAL(TIMER0_COMPA_vect)
{
static byte cnt100 = 0;				// 0.1secJEg
//	PORTB |= (1 << PB0);			// ԊmF(!!!)
	if(tm_1ms)		tm_1ms--;		// 1ms^C}[_EJEg
	if(tmlcd_busy)	tmlcd_busy--;	// LCD busy  ϰ
	if(tmlcd_wait)	tmlcd_wait--;	// LCD ԑ҂ ϰ
	f_tm1ms = 1;					// 1ms tOI
//	100ms^C}[
	cnt100++;
	if(cnt100 >= 100){				// 100ms
		cnt100 = 0;
		if(tm_gainx)	tm_gainx--;		// QCύX^C}[
	}
//	A/DϊJn
	ADCSRA |= (1 << ADSC);			// A/DϊJn
//	PORTB &= ~(1 << PB0);			// (!!!)
}

/********************************/
/*		A/Dϊ荞			*/
/********************************/

/*****	A/Dϊ MUX e[u	*****/
uchar ad_muxtbl[] = {
		0b11001001,		// 0 ch 9 ZT[
		0b11001000,		// 1 ch 8 drd
//		  |||+++++---	MUX ch0
//		  ||+--------	ADLAR
//		  ++---------	REFS AREFpin
};


/*****	A/Dϊ荞ݏ		*****/
//		ϊJn1ms^C}[荞ݓ
//		1ms~2ch~256񕽋  512mSŊm
SIGNAL(ADC_vect)
{
word d;
//	PORTB |= (1 << PB0);			// ԊmF(!!!)
	d  = (uint)ADCL;				// A/Dϊ
	d += ((ADCH & 0x03) << 8);
	if(d > ad_max[ad_ch]){			// őlێ
		ad_max[ad_ch] = d;
	}
	ad_add[ad_ch] += (lword)d;		// ϒlZ
	ad_ch++;						// ch
	if(ad_ch >= AD_CH){				// ch 9,8?
		ad_ch = 0;					// ch 9ɖ߂
		ad_cnt++;					// Z+1
		if(ad_cnt >= AD_AVR){		// Z񐔃`FbN
			ad_cnt = 0;				// ωZŏ
			ad_data[0] = (word)(ad_add[0] / AD_AVR);	// ch 9
			ad_data[1] = (word)(ad_add[1] / AD_AVR);	// ch 8
			ad_add[0] = 0;					// Zۂ	
			ad_add[1] = 0;
			if(ad_ok < 255)		ad_ok++;	// A/DtOon
			ad_blcnt++;
			if(ad_blcnt >= 1){		// _ŗp 512mS
				ad_blcnt = 0;
				f_blink ^= 1;		// _ŃtO]
			}
		}
	}
	ADMUX = ad_muxtbl[ad_ch];		// A/D muxI
//	PORTB &= ~(1 << PB0);			// (!!!)
}

/************************************/
/*		kbc\					*/
/************************************/
//		8~2sACM0802Cgp

/*****	LCD ߰		*****/
//		ް4bitPA4`PA7ɂȂ
//		H,L̏ɓ]
//		ҋ@ԂłPA4`PA7͂
//		RS:PA0, R/W:PA1, E:PA2, Data:PA4`7	*/
#define		LCD_RS			(1 << PA0)				/* PA0 RS		*/
#define		LCD_RW			(1 << PA1)				/* PA1 R/W		*/
#define		LCD_E			(1 << PA2)				/* PA2 E		*/
#define		LCD_DOUT		(PORTA)					/* PA  DATA out	*/
#define		LCD_DINP		(PINA)					/* PA  DATA in 	*/
#define		LCD_DIR			(DDRA)					/* PA  DIR  	*/
#define		lcdinp()		(LCD_DIR=0x07)			/* PA  ͂ 	*/
#define		lcdout()		(LCD_DIR=0xF7)			/* PA  o͂  	*/
#define		lcdwait()		cli()					/* Ԃ  	*/
// #define	lcdwait()		nop()					/* Ԃ  	*/

/*****	1msvϰ	*****/
/* 		ϰ荞݂tmlcd_busytmlcd_wait޳ݶ 		*/
// volatile uchar	tmlcd_busy;			/* LCD busy  ϰ		*/
// volatile uchar	tmlcd_wait;			/* LCD ԑ҂ ϰ		*/

#define	LCDTM_BUSY		20			/* busy  ϰ, 20ms	*/

/*****	وʒuް		*****/
byte	cur_pos;					/* وʒu				*/

/*****	LCD ޏ(busyȂ)	*****/
/*		d̉4bitӰĂ			*/
void lcddwrc(byte d)
{
	cli();							/* 荞݋֎~ */
	d &= 0x0F;
	LCD_DOUT = (d << 4);			/* RS=0,R/W=0	 */
	lcdout();						/* oӰނ */
	lcdwait();
	LCD_DOUT |=  LCD_E;				/* Eĸ	*/
	lcdwait();
	LCD_DOUT &= ~LCD_E;
	lcdwait();
	LCD_DOUT = (d << 4) | LCD_RS | LCD_RW;	/* RS=1,R/W=1	 */
	lcdinp();						/* Ӱނɖ߂Ă */
	sei();							/* 荞ݲȰ */
}

/*****	LCD ް(busyȂ)	*****/
void lcddwrd(byte d)
{
	cli();							/* 荞݋֎~ */
	d &= 0x0F;
	LCD_DOUT = (d << 4) | LCD_RS;	/* RS=1,R/W=0	 */
	lcdout();						/* oӰނ */
	lcdwait();
	LCD_DOUT |=  LCD_E;				/* Eĸ	*/
	lcdwait();
	LCD_DOUT &= ~LCD_E;
	lcdwait();
	LCD_DOUT = (d << 4) | LCD_RS | LCD_RW;	/* RS=1,R/W=1	 */
	lcdinp();						/* Ӱނɖ߂Ă */
	sei();							/* 荞ݲȰ */
}

/*****	LCD 4bit*2 ذ		*****/
byte lcdrd4(void)
{
uchar dh,dl;
	cli();							/* 荞݋֎~ */
	LCD_DOUT |= LCD_E;				/* Eĸ	*/
	lcdwait();
	dh = LCD_DINP;					/* Hް	*/
	LCD_DOUT &= ~LCD_E;
	lcdwait();
	lcdwait();
	LCD_DOUT |= LCD_E;				/* Eĸ	*/
	lcdwait();
	dl = LCD_DINP;					/* Lް	*/
	LCD_DOUT &= ~LCD_E;
	sei();							/* 荞ݲȰ */
	return  (dh & 0xF0) | ((dl >> 4) & 0x0F);
}

/*****	LCD busy 	*****/
/*		busy邢ѱĂ܂ő҂	*/
void lcdbusy(void)
{
byte d;
	LCD_DOUT = LCD_RW;				/* RS=0,R/W=1	 */
	lcdinp();						/* Ӱ */
	tmlcd_busy = LCDTM_BUSY;		/* busy  ϰ */
	do{
		d = lcdrd4();					/* 4bit*2 ްذ	*/
	}while(((d & 0x80) != 0) && 		/* busy ޯĂ1Ȃloop */
		   (tmlcd_busy != 0));			/* ѱ */
	LCD_DOUT = LCD_RS | LCD_RW;			/* RS=1,R/W=1	 */
}

/*****	LCD ްǂݏo	*****/
/*		busy4ޯĂH,L̏	*/
byte lcdrd(void)
{
uchar d;
	lcdbusy();						/* busy҂ */
	LCD_DOUT = LCD_RS | LCD_RW;		/* RS=1,R/W=1	 */
	lcdinp();						/* Ӱ */
	d = lcdrd4();					/* 4bit*2 ްذ	*/
	return d;
}

/*****	LCD ް	*****/
/*		busy4ޯĂH,L̏	*/
void lcdwr(byte d)
{
	lcdbusy();							/* busy҂ */
	lcddwrd(d >> 4);					/* ް H */
	lcddwrd(d);							/* L޲	 */
}

/*****	LCD ޏ	*****/
/*		busy4ޯĂH,L̏	*/
void lcdcmd(byte d)
{
	lcdbusy();							/* busy҂ */
	lcddwrc(d >> 4);					/* ޏ H */
	lcddwrc(d);							/* L޲ */
}

/*****	LCD Ƽ			*****/
/*		4ޯ Ӱ				*/
/*		Ƽق̍ŏbusyłȂ ϰ҂	*/
void lcdinit(void)
{
int i;
static const uchar t[]={		/* ԑ҂ް (1ms) */
	50,						/* 50ms	 	*/
	10,						/* 10ms		*/
	10,						/* 10ms		*/
};
static const uchar w[]={		/* ް */
	0x28,					/*	0 00101000	4bitӰ2sƼ ް	*/
	0x08,					/*	1 00001000	S\				*/
	0x01,					/*	2 00000001	S\ر				*/
	0x06,					/*	3 00000110	ݸ Ӱ			*/
	0x0C,					/*	4 00001100	\on(ٕ\͂Ȃ)	*/
	0x10,					/*	5 00010000	ټĂȂ				*/
	0x80,					/*	6 10000000	DD-RAMڽ				*/
};
	for(i = 0; i < 3; i++){				/* 3 */
		tmlcd_wait = t[i];				/* ԑ҂ް (x1ms) */
		while(tmlcd_wait);
		lcddwrc(0x03);					/* (busy Ȃ) */
	}
	lcdbusy();							/* busy҂ */
	lcddwrc(0x02);						/* 4ޯӰ */
	for(i = 0; i < DIMSIZ(w); i++){		/* 6 */
		lcdcmd(w[i]);					/* ޏ */
	}
}

/*****  LCD  home   *****/
void lcdhome(void)
{
    lcdcmd(0x02);                   /*  00000010 */
    cur_pos=0;
}

/*****  LCD  ړ   *****/
/*      p:0`15             */
void lcdmove(byte n)
{
byte x,y;
static const byte yy[]={        /* ʒu */
    0x00,                       /* 0    */
    0x40,                       /* 8    */
};
	n = n % 16;						/* 0`15͈  */
	cur_pos = n;       	            /* Vʒu */
    y = n / 8;                    	/* Yʒu	*/
    x = n % 8;						/* Xʒu	*/
    lcdcmd(yy[y] + x + 0x80);       /* DD RAM ڽ  */
}

/*****  LCD ʸر     *****/
/*      ق̂home߼޼݂   */
void lcdclr(void)
{
    lcdcmd(0x01);                   /* ʸر,home */
    cur_pos = 0;                    /* وʒu=0 */
}

/*****  LCD s܂Ÿر     *****/
/*      ݍs̍s܂Ÿر     */
/*      -وʒu͎̍s        */
void lcdclreol(void)
{
byte i,x1,x2;
    x1 = cur_pos;                       /* وʒu */
    x2 = ((cur_pos / 8) * 8)+7;         /* s̉E[ (1s8) */
    for(i = x1; i <= x2; i++){
        lcdwr(' ');                     /* space */
    }
    lcdmove(i);                         /* sɶوړ */
}

/*****  LCD 1sر          *****/
/*      ق̂s      */
/*      -وʒu͍s̍[      */
void lcdclrline(void)
{
byte i,x1,x2;
    x1 = (cur_pos / 8) * 8;             /* s̍[ */
    x2 = x1 + 7;                        /* s̉E[ */
    for(i = x1; i <= x2; i++){
        lcdwr(' ');                     /* space */
    }
    lcdmove(x1);                        /* وʒu͍[ */
}

/*****  LCD 1   *****/
/*      sςζوړ    */
/*      Ō܂ŗ擪    */
void lcdputch(byte d)
{
    lcdwr(d);                           /* 1 */
    cur_pos++;                          /* وʒu E */
    if(cur_pos >= 16){                  /* ʔ͈͊O */
        cur_pos = 0;
    }
    lcdmove(cur_pos);                   /* Vوʒu */
}

/*****  LCD 񏑂  *****/
/*      null Ȱ             */
void lcdputs(char *s)
{
    while(*s){                          /* null܂ */
        lcdputch(*s);                   /* 1\ */
        s++;                            /*  */
    }
}

/*****  ʒuwt\      *****/
void lcdpputs(byte p, char *s)
{
    lcdmove(p);                         /* وړ */
    lcdputs(s);                         /* \ */
}

/*****  LCDwtpL\   *****/
/*      printfƓ@\                        */
void lcdprintf(char *s, ...)
{
va_list vp;
char bff[20];                              /* 20ޯ̧ */
    va_start(vp,s);
    vsprintf(bff,s,vp);
    lcdputs(bff);
    va_end(vp);
}

/*****  LCDʒuwtw蕶\ *****/
/*      p:ʒu                          */
void lcdpprintf(byte p,char *s, ...)
{
va_list vp;
char bff[20];                              /* 20ޯ̧ */
    va_start(vp,s);
    vsprintf(bff,s,vp);
    lcdpputs(p, bff);
    va_end(vp);
}

/****************************************/
/*		XCb``FbN				*/
/****************************************/

/*****	XCb`		*****/
//		ƃ`𔻒f
//		1msTCNŃR[
void swchk(void)
{
static byte chk = 0;
static word tm  = 0;
    if(tm)    tm--;          	// 1msϰ
    switch(chk){
	  case 0:			// ̂m肳
	  	if(PIN_SW != 0){
			tm = 10;
			chk++;
		}		
		break;
	  case 1:			// ̌p
	  	if(PIN_SW == 0)		chk = 0;	// onȂoffmF
		else{
			if(tm == 0)		chk++;		// offm
		}
		break;
      case 2:         	// ݑ҂
        if(PIN_SW == 0){     			// on ?
          tm = 10;                     	// 10ms
          chk++;
        }
        break;
      case 3:         // 10ms
        if(PIN_SW == 0){     			// on p
          	if(tm == 0){                // ѱ
        		f.swon = 1;             // SW on m
           		chk = 0;				// It҂
          	}   
        }
        else{                           // off
          chk--;    	                // I҂ɖ߂
        }
        break;
    }
}

/********************************/
/*		ZT[QCؑ		*/
/********************************/

/*****	ZT[QCf[^	*****/
//		GC2 GC1
//		  0   0   	Vbg_E
//		  0   1   	HQC
//		  1   0   	MQC
//		  1   1   	LQC
//		MPX B A
//			0 0		4.7k
//			0 1		47k
//			1 0		470k

/*****	QCݒf[^	*****/
struct{
	byte	data;				// ZT[QC{Rؑ
	byte	disp;				// QCW,\[h
	char 	*msg;				// QC敪\
}gain_data[] ={
	{ 0b00000011,	0,	"L0" },		// 0  L0	102300 102.3kLx
	{ 0b00000111,	1,	"L1" },		// 1  L1	10230  10.23kLx
	{ 0b00000010,	1,	"M0" },		// 2  M0	10230  
	{ 0b00001011,	2,	"L2" },		// 3  L2	1023     1023Lx 
	{ 0b00000110,	2,	"M1" },		// 4  M1	1023   
	{ 0b00000001,	2,	"H0" },		// 5  H0	1023
	{ 0b00001010,	3,	"M2" },		// 6  M2	102.3   102.3Lx
	{ 0b00000101,	3,	"H1" },		// 7  H1	102.3
	{ 0b00001001,	4,	"H2" },		// 8  H2	10.23   10.23Lx
	//	 ||||||+----	PB0  GC1
	//	 |||||+-----	PB1  GC2
	//	 ||||+------	PB2  MPX A
	//	 |||+-------	PB3  MPX B
	//	 ||+--------	PB4 in  SW (pull up)
	//	 |+---------	PB5 in  ADC8
	//	 +----------	PB6 in  ADC9
};

/*****	ZT[QCݒ		*****/
void gainset(void)
{
	PORTB = (PORTB & 0xF0) | gain_data[sens_gain].data;
}

/*****	ZT[QCؑ		*****/
//		QC
void gainnext(void)
{
	sens_gain++;						// QC+1
	if(sens_gain >= DIMSIZ(gain_data))	sens_gain = 0;
	gainset();							// QCݒ
	f.gdisp  = 1;						// QC\tO on
	f.gainx  = 1;						// QCύXtO on
	f.lxdisp = 1;						// Ɠx\tOI
	tm_gainx = gainx_tm;				// EEPROMZ[us҂
}

/*****	QCf[^EEPROMɃZ[u	*****/
//		ύXă^CAbvs
void gainsave(void)
{
	if((f.gainx) &&				// QCύX
	   (tm_gainx == 0)){		// ^CAbv
		eeprom_busy_wait();						// ANZX\҂
		eeprom_update_byte(&eep_sensgain, sens_gain);	// f[^XV
		f.gainx = 0;						// XV
		f.lxdisp = 1;						// Ɠx\tOI
	}
}

/*****	Ɠx\		*****/
//		QCݒɂ\ς
//		10bitől(1023)Ȃ_
void displux(void)
{
word d, m;
	cli();							// 荞݋֎~
	d = ad_data[AD_SENS];			// ZT[oA/Dϒl
	m = ad_max[AD_SENS];			// ZT[A/Dől
	ad_max[AD_SENS] = 0;			// max[
	sei();							// 荞ݍĊJ
	lcdpputs(6, "Lx");
    lcdmove(0);						// وړ
	if((m == 1023) &&				// maxI[o[WȂ_
	   (f_blink == 0)){
		lcdputs("      ");
	}
	else{       // QC敪ŕ\ς
		switch(gain_data[sens_gain].disp){	// \敪
		  case 0:		// L1		102300  102.3kLx
			lcdprintf("%4u00", d);
			break;
		  case 1:		// L2,M1	10230   10.23kLx
			lcdprintf("%5u0",  d);
			break;
		  case 2:		// L3,M2,H1	1023    __1023Lx
			lcdprintf("%6u", d);
			break;
		  case 3:		// M3,H2	102.3   _102.3Lx
			lcdprintf("%4u.%u", d / 10, d  % 10);
			break;
		  case 4:		// H3	    10.23   _10.23Lx
			lcdprintf("%3u.%02u", d / 100, d  % 100);
			break;
		}
	}
}

/****************************/
/*		eXg[h		*/
/****************************/

/*****	eXg[h		*****/
//		NswIp
void testmode(void)
{
word d1,d2;
	f.swon  = 0;				// XCb`tONA
	f.gdisp = 1;				// QC\tOI
	while(1){
//		PINB |= (1 << PB1);		// (!!!)
		if(f_tm1ms){			// 1msTCN
			f_tm1ms = 0;
			swchk();			// SW̓`FbN
			gainsave();			// QCf[^EEPROMɃZ[u
		}
		if(ad_ok || f.lxdisp){		// A/Dl\
			ad_ok = 0;
			f.lxdisp = 0;
			cli();				// 荞݋֎~
			d1 = ad_data[AD_SENS];		// ZT[o
			d2 = ad_data[AD_BAT];		// drd
			sei();				// 荞ݍĊJ
			lcdpprintf(0, "%04d", d1);	// 0`1023
			lcdpprintf(8, "%04d", d2);
		}
		if(f.gdisp){			// QC\
			f.gdisp = 0;
			lcdpprintf(4,   "%4d", low_bat);	// LOW BATݒ
			lcdpprintf(8+5, "%d",  sens_gain);	// 0`8
			lcdpprintf(8+6, "%s",  gain_data[sens_gain].msg);	// QC敪
		}
		if(f.swon){				// SW on ?
			f.swon = 0;
			gainnext();			// QC+1
		}
	}
}

/****************************/
/*		l`hms		*/
/****************************/

/*****	l`hm			*****/
int main(void)
{
word d;
	ioinit();					// I/OƼ
	eeptoram();					// EEPROMRAM ǂݏo
	sei();						// 荞ݲȰ
	lcdinit();					// tƼ
	lcdpputs(0, "Lux       Sensor");		// ^Cg
//			     0123456701234567
	gainset();					// ZT[QCݒ
	ad_ok = 0;
	while(ad_ok < 4);			// 512mS~4 ҂
	lcdclr();					// ʃNA
//	eXg[h
	if(PIN_SW == 0)		testmode();		// dISWI

//	sloop
	f.gdisp = 1;				// QC\tOI
	while(1){
		if(f_tm1ms){			// 1msTCN
			f_tm1ms = 0;
			swchk();			// SW̓`FbN
			gainsave();			// QCf[^EEPROMɃZ[u
		}
		if(f.swon){				// SW on?
			f.swon = 0;
			gainnext();			// QC+1
		}
//	A/Dϊ`FbN
		if(ad_ok || f.lxdisp){	// A/Dϊ
			ad_ok = 0;
			f.lxdisp = 0;
			displux();			// Ɠx\
//	drd`FbN
			cli();						// 荞݋֎~
			d = ad_data[AD_BAT];		// drd
			sei();						// 荞ݍĊJ
		    lcdmove(8);					// وړ
			if(f.batlo){				// LOW BAT
				if(d > low_bath)	f.batlo = 0;	// qXeVX
			}
			else{
				if(d < low_bat)		f.batlo = 1;	// LOW BATo
			}
			if((f.batlo) &&				// LOW BATœ_
	  		   (f_blink != 0))	lcdputs("BL");
			else				lcdputs("  ");
//	QCύX u:v\
		    lcdmove(8+5);					// وړ
			if(f.gainx)		lcdputch(':');	// QCEEPROMݑ҂
			else			lcdputch(' ');
		}
//	QC\
		if(f.gdisp){			// QC\
			f.gdisp = 0;
			lcdpprintf(8+3, "G%d", gain_data[sens_gain].disp);	// W
			lcdpprintf(8+6, "%s",  gain_data[sens_gain].msg);	// QC敪
		}
	}
}

/*====	end of "PHOTO_SENS1.c"	====*/
